# Base git commit: bfe01a5ba249
# (Linux 3.17)
# 
# Author:    Russell King (Fri 20 Jun 19:26:53 BST 2014)
# Committer: Russell King (Mon 27 Oct 17:20:41 GMT 2014)
# 
#   net: fec: try better napi packet processing algorithm
# 
#   Signed-off-by: Russell King
# 
#   06230bbd17b9c9a236f793d0146dfb672220128d
#    drivers/net/ethernet/freescale/fec_main.c | 33 +++++++++++++++++++------------
#    1 file changed, 20 insertions(+), 13 deletions(-)
# 
# Author:    Russell King (Sat 15 Mar 01:23:14 GMT 2014)
# Committer: Russell King (Fri 17 Oct 14:35:57 BST 2014)
# 
#   Rest
# 
#   f1d1b187e56ac66aba52042ecc30866c7a7ed4a2
#    arch/arm/mm/fault.c                       |  1 +
#    drivers/net/ethernet/freescale/fec.h      |  2 ++
#    drivers/net/ethernet/freescale/fec_main.c | 35 ++++++++++++++++++++++++-------
#    kernel/softirq.c                          | 11 +++++++---
#    4 files changed, 39 insertions(+), 10 deletions(-)
# 
# Author:    Russell King (Fri 21 Mar 20:31:56 GMT 2014)
# Committer: Russell King (Fri 17 Oct 14:35:56 BST 2014)
# 
#   net:fec: move copying receive function out of line
# 
#   Signed-off-by: Russell King
# 
#   99b261307939e1cb6a96e436ce5dc058cbfacfb1
#    drivers/net/ethernet/freescale/fec_main.c | 149 +++++++++++++++---------------
#    1 file changed, 72 insertions(+), 77 deletions(-)
# 
# Author:    Russell King (Wed 12 Mar 19:47:47 GMT 2014)
# Committer: Russell King (Fri 17 Oct 14:35:54 BST 2014)
# 
#   net:fec: implement almost zero-copy receive path
# 
#   iMX6 SoCs have an IP accelerator which can pad and strip two bytes in
#   the FIFO at the beginning of each packet.  Since the FEC has alignment
#   restrictions on the buffer addresses, this feature is particularly
#   interesting for receive as it allows us to receive an appropriately
#   aligned packet for IP.
# 
#   This allows us to reduce the CPU overhead by avoiding copying large
#   packets - and in the spirit of all network drivers which use this trick,
#   we provide a copybreak tunable which allows the packet size to be
#   copied to be adjusted.
# 
#   Signed-off-by: Russell King
# 
#   70d8a8a74a1627de5cd472b8bb0ce5755e5a6eee
#    drivers/net/ethernet/freescale/fec_main.c | 195 +++++++++++++++++++++++-------
#    1 file changed, 149 insertions(+), 46 deletions(-)
# 
# Author:    Russell King (Wed 12 Mar 17:52:38 GMT 2014)
# Committer: Russell King (Fri 17 Oct 14:35:53 BST 2014)
# 
#   net:fec: move syncing of receive buffer back to device directly after copy
# 
#   Move the syncing for the DMA buffer back to the device immediately
#   after we've done with copying data from it.  This means the logic in
#   the receive path handing the copying of data is now located together.
# 
#   Signed-off-by: Russell King
# 
#   ba62cb8da3093e15fd0db8a5a0bcd612e6dff1e3
#    drivers/net/ethernet/freescale/fec_main.c | 5 +++--
#    1 file changed, 3 insertions(+), 2 deletions(-)
# 
# Author:    Russell King (Wed 12 Mar 17:51:42 GMT 2014)
# Committer: Russell King (Fri 17 Oct 14:35:51 BST 2014)
# 
#   net:fec: move final receive to separate function
# 
#   Move the final receive code sequence to a separate function.
#   Performance tests show that having lots of code integrated into one
#   big function can make the driver performance very dependent on
#   compiler behaviour, and more reliable performance can be obtained
#   by separating this out.
# 
#   Signed-off-by: Russell King
# 
#   cf532149ae68a1eeb31d2a07f0949ac116793b4d
#    drivers/net/ethernet/freescale/fec_main.c | 43 +++++++++++++++++--------------
#    1 file changed, 24 insertions(+), 19 deletions(-)
# 
# Author:    Russell King (Wed 12 Mar 17:49:28 GMT 2014)
# Committer: Russell King (Fri 17 Oct 14:35:50 BST 2014)
# 
#   net:fec: simplify packet data copying and vlan tag removal
# 
#   Implement this as two distinct code paths: this allows non-tagged
#   traffic to be copied in one go, whereas tagged traffic needs to be
#   copied in two separate chunks.
# 
#   Signed-off-by: Russell King
# 
#   137d6c7a9eed27262541e8719292c76e3242e9d8
#    drivers/net/ethernet/freescale/fec_main.c | 24 ++++++++++++------------
#    1 file changed, 12 insertions(+), 12 deletions(-)
# 
# Author:    Russell King (Wed 12 Mar 17:45:57 GMT 2014)
# Committer: Russell King (Fri 17 Oct 14:35:48 BST 2014)
# 
#   net:fec: extract and record vlan tag receive processing in one place
# 
#   Rather than having the vlan tag processing scattered in multiple
#   different places, we can now localize the reading of the tag with
#   storing the tag in the skb.  Group this code together.
# 
#   Signed-off-by: Russell King
# 
#   e8d8ba2f37b2f4fdf10e690e7e07ee9ff164e857
#    drivers/net/ethernet/freescale/fec_main.c | 14 +++++---------
#    1 file changed, 5 insertions(+), 9 deletions(-)
# 
# Author:    Russell King (Wed 12 Mar 17:41:12 GMT 2014)
# Committer: Russell King (Fri 17 Oct 14:35:46 BST 2014)
# 
#   net:fec: move skb allocation earlier
# 
#   Move the skb allocation before we sync the buffer for CPU access.  In
#   order to do this, we need to detect whether the packet contains a VLAN
#   header so we can adjust the packet size appropriately.
# 
#   This allows us to tidy the code a little in the following patches.
# 
#   Signed-off-by: Russell King
# 
#   932e908a07bb584119b7aee4280b95adf415f246
#    drivers/net/ethernet/freescale/fec_main.c | 45 ++++++++++++++++---------------
#    1 file changed, 24 insertions(+), 21 deletions(-)
# 
# Author:    Russell King (Wed 12 Mar 19:24:42 GMT 2014)
# Committer: Russell King (Fri 17 Oct 14:35:45 BST 2014)
# 
#   net:fec: move quirks into fec_enet_private data structure
# 
#   Move the quirks bitmap into the fec_enet_private data structure so we don't
#   need to keep reading it via a chain of pointers.
# 
#   Signed-off-by: Russell King
# 
#   7528c9d58454de2aa661ab97a62a92c57a49c32a
#    drivers/net/ethernet/freescale/fec.h      |  1 +
#    drivers/net/ethernet/freescale/fec_main.c | 48 ++++++++++++-------------------
#    2 files changed, 19 insertions(+), 30 deletions(-)
# 
# Author:    Russell King (Tue  1 Apr 23:06:09 BST 2014)
# Committer: Russell King (Fri 17 Oct 14:35:43 BST 2014)
# 
#   net:fec: unsorted hacks
# 
#   Signed-off-by: Russell King
# 
#   7e291d514886ac81463014078292fbe32f08ae76
#    drivers/net/ethernet/freescale/fec.h      | 15 ++++--
#    drivers/net/ethernet/freescale/fec_main.c | 85 +++++++++++++++++++------------
#    2 files changed, 63 insertions(+), 37 deletions(-)
# 
# Author:    Russell King (Mon 31 Mar 14:47:06 BST 2014)
# Committer: Russell King (Fri 17 Oct 14:35:42 BST 2014)
# 
#   net:fec: even larger rings
# 
#   Signed-off-by: Russell King
# 
#   9f8008020a8293074a65f5f23ec1f40ac97d6beb
#    drivers/net/ethernet/freescale/fec_main.c | 68 +++++++++++++++++++------------
#    1 file changed, 42 insertions(+), 26 deletions(-)
# 
# Author:    Russell King (Mon 31 Mar 11:06:08 BST 2014)
# Committer: Russell King (Fri 17 Oct 14:35:40 BST 2014)
# 
#   net:fec: remove unnecessary code
# 
#   fec_enet_bd_init() already frees the transmit skbuffs, so there's no
#   need for fec_restart() to do this again.
# 
#   Signed-off-by: Russell King
# 
#   1b526028590f6746a36d60ca9e51b44cfee6a6fe
#    drivers/net/ethernet/freescale/fec.h      | 1 -
#    drivers/net/ethernet/freescale/fec_main.c | 8 --------
#    2 files changed, 9 deletions(-)
# 
# Author:    Russell King (Thu 27 Mar 15:40:30 GMT 2014)
# Committer: Russell King (Fri 17 Oct 14:35:38 BST 2014)
# 
#   net:fec: allocate descriptor rings at device open, and free on device close
# 
#   The driver has had a memory leak for quite some time: when the device is
#   probed, we allocate a page for the descriptor rings, but we never free
#   this.
# 
#   Rather than trying to free it on the various probe failure paths, move
#   its allocation to device open time - we have to restart the FEC for this
#   to take effect.  This also means we can free the descriptor rings when
#   we clean up in the device close function, which gives this a nice
#   symmetry.
# 
#   Signed-off-by: Russell King
# 
#   bfba6f845998dfb17272e64fccd9b2e7e1d88d7b
#    drivers/net/ethernet/freescale/fec_main.c | 81 +++++++++++++++----------------
#    1 file changed, 39 insertions(+), 42 deletions(-)
# 
# Author:    Russell King (Tue 25 Mar 21:20:02 GMT 2014)
# Committer: Russell King (Fri 17 Oct 14:35:37 BST 2014)
# 
#   net:fec: convert scatter-gather support
# 
#   Add scatter-gather support for SKB transmission.  This allows the
#   driver to make use of GSO, which when enabled allows the iMX6Q to
#   increase TCP transmission throughput from about 320 to 420Mbps,
#   measured with iperf 2.0.5
# 
#   We adjust the minimum transmit ring space according to whether SG
#   support is enabled or not.  This allows non-SG configurations to avoid
#   the tx ring reservation necessary for SG, thereby making full use of
#   their available ring (since non-SG requires just one tx ring entry per
#   packet.)
# 
#   Signed-off-by: Russell King
# 
#   4ac5dc6cea6751372633c231ba732ac969f8c9b3
#    drivers/net/ethernet/freescale/fec.h      |   1 +
#    drivers/net/ethernet/freescale/fec_main.c | 183 ++++++++++++++----------------
#    2 files changed, 87 insertions(+), 97 deletions(-)
# 
# Author:    Russell King (Wed 18 Jun 23:28:09 BST 2014)
# Committer: Russell King (Fri 17 Oct 14:35:35 BST 2014)
# 
#   Revert FEC commits
# 
#   This reverts commit d5e42c86e07935f3cab4dcfca787a733146d0c70
#   ("net: fec: Don't clear IPV6 header checksum field when IP accelerator enable").
# 
#   This reverts commit 79f339125ea316e910220e5f5b4ad30370f4de85
#   ("net: fec: Add software TSO support"), as 96c50caa5148 ("net: fec:
#   Enable IP header hardware checksum") causes a regression with IPv6 by
#   overwriting the location where the IPv4 header checksum would be:
# 
#   -  0x0000:  6000 0000 0028 0640 fd8f 7570 feb6 0001 `....(.@..up....
#   +  0x0000:  6000 0000 0028 0640 fd8f 0000 feb6 0001 `....(.@........
# 
#   This reverts commit 96c50caa5148e0e0a077672574785700885c6764
#   ("net: fec: Enable IP header hardware checksum"), as it causes a
#   regression with IPv6 by overwriting the location where the IPv4
#   header checksum would be:
# 
#   -  0x0000:  6000 0000 0028 0640 fd8f 7570 feb6 0001 `....(.@..up....
#   +  0x0000:  6000 0000 0028 0640 fd8f 0000 feb6 0001 `....(.@........
# 
#   37ad6b09d60f1667826284e8c0096d6117fab82d
#    drivers/net/ethernet/freescale/fec.h      |   6 -
#    drivers/net/ethernet/freescale/fec_main.c | 288 +++---------------------------
#    2 files changed, 24 insertions(+), 270 deletions(-)
# 
# Author:    Russell King (Thu 27 Mar 16:43:25 GMT 2014)
# Committer: Russell King (Fri 17 Oct 14:35:34 BST 2014)
# 
#   net:fec: add ethtool support for tx/rx ring sizes
# 
#   Add ethtool support to retrieve and set the transmit and receive ring
#   sizes.  This allows runtime tuning of these parameters, which can
#   result in better throughput with gigabit parts.
# 
#   Signed-off-by: Russell King
# 
#   3981daaed7772bf25b0f96323520e53bc78bf8cd
#    drivers/net/ethernet/freescale/fec_main.c | 47 +++++++++++++++++++++++++++++++
#    1 file changed, 47 insertions(+)
# 
# Author:    Russell King (Wed 12 Mar 17:32:11 GMT 2014)
# Committer: Russell King (Fri 17 Oct 14:35:32 BST 2014)
# 
#   net: fec: move removal of FCS from packet length to single location
# 
#   Rather than keep subtracting four off the packet length throughout the
#   receive path, do it at the point we read the packet length from the
#   descriptor.
# 
#   Signed-off-by: Russell King
# 
#   a60caabbf5f4ac525ec3807128b87f57dd01278a
#    drivers/net/ethernet/freescale/fec_main.c | 17 ++++++++++-------
#    1 file changed, 10 insertions(+), 7 deletions(-)
# 
# Author:    Russell King (Mon 31 Mar 14:33:07 BST 2014)
# Committer: Russell King (Fri 17 Oct 14:35:29 BST 2014)
# 
#   net: fec: avoid checking more flags than necessary in rx path
# 
#   Avoid checking for the enhanced buffer descriptor flag and the receive
#   checksumming/vlan flags - we now only set these feature flags if we
#   already know that we have enhanced buffer descriptors.
# 
#   Signed-off-by: Russell King
# 
#   a1beb33c36178af3b1afda7ab47cbeb58d722b56
#    drivers/net/ethernet/freescale/fec_main.c | 4 +---
#    1 file changed, 1 insertion(+), 3 deletions(-)
# 
# Author:    Russell King (Mon 31 Mar 14:30:45 BST 2014)
# Committer: Russell King (Fri 17 Oct 14:35:27 BST 2014)
# 
#   net: fec: only enable CTAG_RX and IP checksumming if we have enhanced buffer descriptors
# 
#   Only set the vlan tag and ip checksumming options if we have enhanced
#   buffer descriptors - enhanced descriptors are required for these
#   features.
# 
#   Signed-off-by: Russell King
# 
#   dfeb8560400126ece53da06c24fc25c53eed44f0
#    drivers/net/ethernet/freescale/fec_main.c | 25 ++++++++++++++-----------
#    1 file changed, 14 insertions(+), 11 deletions(-)
# 
# Author:    Russell King (Mon 31 Mar 15:49:50 BST 2014)
# Committer: Russell King (Fri 17 Oct 14:35:26 BST 2014)
# 
#   net: fec: move vlan receive flag into our private flags
# 
#   Signed-off-by: Russell King
# 
#   493ee26814f2bda27e7075e789d4e6045561f675
#    drivers/net/ethernet/freescale/fec_main.c | 14 ++++++++++++--
#    1 file changed, 12 insertions(+), 2 deletions(-)
# 
# Author:    Russell King (Mon 31 Mar 13:48:50 BST 2014)
# Committer: Russell King (Fri 17 Oct 14:35:24 BST 2014)
# 
#   net: fec: move receive checksum flags into new flags member
# 
#   The receive checksum flag is only changed upon ethtool configuration,
#   so move it into the flags member.  In any case, this is checked
#   alongside the BUFDESC_EX flag.
# 
#   Signed-off-by: Russell King
# 
#   3793558b231361dc545e9e0e345b21cd9660e738
#    drivers/net/ethernet/freescale/fec.h      |  2 --
#    drivers/net/ethernet/freescale/fec_main.c | 11 ++++++-----
#    2 files changed, 6 insertions(+), 7 deletions(-)
# 
# Author:    Russell King (Mon 31 Mar 13:45:52 BST 2014)
# Committer: Russell King (Fri 17 Oct 14:35:22 BST 2014)
# 
#   net: fec: move bufdesc_ex flag into flags
# 
#   Add a new flags field to contain the mostly static driver configuration,
#   the first of which is the bufdesc_ex flag.
# 
#   Signed-off-by: Russell King
# 
#   c44615ae10c0df303b484f580d3c2cd0d1c5f8aa
#    drivers/net/ethernet/freescale/fec.h      |  3 +-
#    drivers/net/ethernet/freescale/fec_main.c | 65 +++++++++++++++++--------------
#    2 files changed, 37 insertions(+), 31 deletions(-)
# 
# Author:    Russell King (Mon 31 Mar 10:46:21 BST 2014)
# Committer: Russell King (Fri 17 Oct 14:35:21 BST 2014)
# 
#   net: fec: add locking for MDIO bus access
# 
#   Both fec_restart() and fec_stop() both perform a reset of the FEC.  This
#   reset can result in an in-process MDIO transfer being terminated, which
#   can lead to the MDIO read/write functions timing out.  Add some locking
#   to prevent this occuring.
# 
#   We can't use a spinlock for this as the MDIO accessor functions use
#   wait_for_completion_timeout(), which sleeps.
# 
#   Signed-off-by: Russell King
# 
#   dbd69f5aeb1ae857c76daf1f0abeaa39015a6886
#    drivers/net/ethernet/freescale/fec.h      |  3 +++
#    drivers/net/ethernet/freescale/fec_main.c | 30 +++++++++++++++++++++++++++++-
#    2 files changed, 32 insertions(+), 1 deletion(-)
# 
# Author:    Russell King (Sun 30 Mar 23:59:24 BST 2014)
# Committer: Russell King (Fri 17 Oct 14:35:19 BST 2014)
# 
#   net: fec: consolidate common parts of mdio read/write
# 
#   There is a commonality to fec_enet_mdio_read() and fec_enet_mdio_write()
#   which can be factored out.  Factor that commonality out, since we need
#   to add some locking to prevent resets interfering with MDIO accesses.
# 
#   Signed-off-by: Russell King
# 
#   ada950bc676bbcd7140f1422e700e183b376f2ab
#    drivers/net/ethernet/freescale/fec_main.c | 41 +++++++++++++------------------
#    1 file changed, 17 insertions(+), 24 deletions(-)
# 
# Author:    Russell King (Wed 18 Jun 22:56:30 BST 2014)
# Committer: Russell King (Fri 17 Oct 14:35:18 BST 2014)
# 
#   net: fec: adjust ring threshold according to SG setting
# 
#   When SG is enabled, we must ensure that there are up to 1+MAX_SKB_FRAGS
#   free entries in the ring.  When SG is disabled, this can be reduced to
#   one, and we can allow smaller rings.  Adjust this setting according to
#   the state of SG.
# 
#   Signed-off-by: Russell King
# 
#   55993c83effcef1d4d3ebcee4ee01151547699b0
#    drivers/net/ethernet/freescale/fec.h      |  1 +
#    drivers/net/ethernet/freescale/fec_main.c | 44 +++++++++++++++++++++++++++++--
#    2 files changed, 43 insertions(+), 2 deletions(-)
# 
# Author:    Russell King (Tue 11 Mar 19:22:16 GMT 2014)
# Committer: Russell King (Fri 17 Oct 14:35:16 BST 2014)
# 
#   net: fec: better indexing for receive descriptor ring
# 
#   Extend the previous commit to the receive descriptor ring as well.  This
#   gets rid of the two nextdesc/prevdesc functions, since we now just need
#   to get the descriptor for an index instead.
# 
#   Signed-off-by: Russell King
# 
#   12d03c5f1759e2298e3017d701a668fff7da7757
#    drivers/net/ethernet/freescale/fec.h      |   2 +-
#    drivers/net/ethernet/freescale/fec_main.c | 102 ++++++++++--------------------
#    2 files changed, 34 insertions(+), 70 deletions(-)
# 
# Author:    Russell King (Tue 11 Mar 18:06:47 GMT 2014)
# Committer: Russell King (Fri 17 Oct 14:35:14 BST 2014)
# 
#   net: fec: better indexing for transmit descriptor ring
# 
#   Maintaining the transmit ring position via pointers is inefficient,
#   especially when it involves complex pointer manipulation, and overlap
#   with the receive descriptor logic.
# 
#   Re-implement this using indexes, and a single function which returns
#   the descriptor (appropriate to the descriptor type).  As an additional
#   benefit, using a union allows cleaner access to the descriptor.
# 
#   Signed-off-by: Russell King
# 
#   e612c4322c625c5eb93c8a4f2b72860e7c0c12c1
#    drivers/net/ethernet/freescale/fec.h      |   6 +-
#    drivers/net/ethernet/freescale/fec_main.c | 188 +++++++++++++++---------------
#    2 files changed, 98 insertions(+), 96 deletions(-)
# 
# Author:    Russell King (Sun 23 Mar 15:17:13 GMT 2014)
# Committer: Russell King (Fri 17 Oct 14:35:13 BST 2014)
# 
#   net: fec: use a union for the buffer descriptors
# 
#   Using a union gives clearer C code than the existing solution, and
#   allows the removal of some odd code from the receive path whose
#   purpose was to merely store the enhanced buffer descriptor.
# 
#   Signed-off-by: Russell King
# 
#   7e7801e54ee1429d7ec4c87fd12633f86b100f9f
#    drivers/net/ethernet/freescale/fec.h      |  14 +-
#    drivers/net/ethernet/freescale/fec_main.c | 256 ++++++++++++++----------------
#    2 files changed, 130 insertions(+), 140 deletions(-)
# 
# Author:    Russell King (Sun 23 Mar 22:27:17 GMT 2014)
# Committer: Russell King (Fri 17 Oct 14:35:11 BST 2014)
# 
#   net: fec: add barrier to receive path to ensure proper ordering
# 
#   Just as we need a barrier in the transmit path, we also need a barrier
#   in the receive path to ensure that we don't modify a handed over
#   descriptor.
# 
#   Signed-off-by: Russell King
# 
#   9d498e576d9caa2240a2c85d1b664da046c94d08
#    drivers/net/ethernet/freescale/fec_main.c | 20 +++++++++++++-------
#    1 file changed, 13 insertions(+), 7 deletions(-)
# 
# Author:    Russell King (Tue 11 Mar 10:35:58 GMT 2014)
# Committer: Russell King (Fri 17 Oct 14:35:10 BST 2014)
# 
#   net: fec: add barrier to transmit path to ensure proper ordering
# 
#   Ensure that the writes to the descriptor data is visible to the hardware
#   before the descriptor is handed over to the hardware.
# 
#   Having discussed this with Will Deacon, we need a wmb() between writing
#   the descriptor data and handing the descriptor over to the hardware.
#   The corresponding rmb() is in the ethernet hardware.
# 
#   Signed-off-by: Russell King
# 
#   a29dc07047c66ae31354b3953e136356b2f92cf5
#    drivers/net/ethernet/freescale/fec_main.c | 7 +++++++
#    1 file changed, 7 insertions(+)
# 
# Author:    Russell King (Tue 25 Mar 20:46:37 GMT 2014)
# Committer: Russell King (Fri 17 Oct 14:35:08 BST 2014)
# 
#   net: fec: fix calculation of free packets
# 
#   The FEC maintains two pointers into the transmit ring:
# 
#   next  - this is the insertion point in the ring, and points at a free
#           entry which can be written to.
#   dirty - this is the last dirty entry which we successfully cleaned, and
#           is always incremented prior to cleaning an entry.
# 
#   The calculation used for the number of free packets is slightly buggy,
#   which is:
# 
#   	entries = dirty - next - 1
#   	if (entries < 0)
#   		entries += size;
# 
#   Let's take some examples:
# 
#   At ring initialisation, dirty is set to size-1, and next is set to 0.
#   This gives:
# 
#   	entries = size-1 - 0 - 1 = size - 2 => size - 2
# 
#   But hang on, we have no packets in the empty ring, so why "size - 2" ?
#   Let's also check if we back the pointers up by one position - so
#   dirty=size-2, next=size-1.
# 
#   	entries = size-2 - size-1 - 1 = -2 - -1 - 1 = -2 => size - 2
# 
#   Okay, so that's the same.  Now, what about the "ring full" criteria.
#   We can never completely fill the transmit ring, because a completely
#   full ring is indistinguishable from a completely empty ring.  We
#   reserve one entry to permit us to keep a distinction.
# 
#   Hence, our "full" case is when both pointers are equal, so dirty=size-1,
#   next=size-1.
# 
#   	entries = size-1 - size-1 - 1 = -1 => size - 1
# 
#   This is where things break down - in this case, the function is not
#   returning the number of free entries in the ring, because it should
#   be zero!
# 
#   Fix this by changing the calculation to something which reflects the
#   actual ring behaviour:
# 
#   	entries = dirty - next;
#   	if (entries < 0)
#   		entries += size;
# 
#   Plugging the above three cases into this gives:
# 
#   	entries = size-1 - 0 = size - 1 => size - 1
#   	entries = size-2 - size-1 = -1 => size - 1
#   	entries = size-1 - size-1 = 0 => 0
# 
#   Here, we have more correct behaviour (remembering that we have reserved
#   one entry as described above).
# 
#   The perverse thing is that every test at this function's called site
#   almost took account of the off-by-one error.  Let's fix this to have
#   saner semantics - returning the number of permissible free entries in
#   the ring which can then be compared using expected tests against our
#   required numbers of packets.
# 
#   Signed-off-by: Russell King
# 
#   0fcc609a72a757088042d8557812986f6e4621a4
#    drivers/net/ethernet/freescale/fec_main.c | 13 +++++--------
#    1 file changed, 5 insertions(+), 8 deletions(-)
# 
# Author:    Russell King (Tue 25 Mar 20:46:37 GMT 2014)
# Committer: Russell King (Fri 17 Oct 14:35:06 BST 2014)
# 
#   net: fec: move netif_wake_queue() out of transmit loop
# 
#   It is wasteful to keep checking whether we're stopped, and the number
#   of free packets to see whether we should restart the queue for each
#   entry in the ring which we process.  Move this to the end of the
#   processing so we check once per ring clean.
# 
#   Signed-off-by: Russell King
# 
#   78ae10037e799d649ac0421943fa62b1d10d0081
#    drivers/net/ethernet/freescale/fec_main.c | 10 ++++------
#    1 file changed, 4 insertions(+), 6 deletions(-)
# 
# Author:    Russell King (Tue 25 Mar 20:46:37 GMT 2014)
# Committer: Russell King (Fri 17 Oct 14:35:05 BST 2014)
# 
#   net: fec: clean up fec_enet_get_free_txdesc_num() callsites
# 
#   Clean up the various callsites to this function; most callsites
#   are using a temporary variable and immediately following it with
#   a test.  There is no need of a temporary variable for this.
# 
#   Signed-off-by: Russell King
# 
#   dc8d9ba5042c821a027194ec12d5c903bac7e5e5
#    drivers/net/ethernet/freescale/fec_main.c | 17 +++++------------
#    1 file changed, 5 insertions(+), 12 deletions(-)
# 
# Author:    Russell King (Thu 27 Mar 14:50:28 GMT 2014)
# Committer: Russell King (Fri 17 Oct 14:35:04 BST 2014)
# 
#   net: fec: move transmit dma ring address calculation to fec_enet_init()
# 
#   Move the calculation of the transmit DMA ring address to fec_enet_init()
#   so the CPU and DMA ring address calculations are localised.
# 
#   Signed-off-by: Russell King
# 
#   5bf5fcf8a52a0cfd09cd18565ddb41fccb0bade2
#    drivers/net/ethernet/freescale/fec.h      |  3 ++-
#    drivers/net/ethernet/freescale/fec_main.c | 26 +++++++++++++-------------
#    2 files changed, 15 insertions(+), 14 deletions(-)
# 
# Author:    Russell King (Fri 21 Mar 18:03:25 GMT 2014)
# Committer: Russell King (Fri 17 Oct 14:35:02 BST 2014)
# 
#   net: fec: increase receive ring size
# 
#   Increasing the receive ring size allows more packets to be received
#   before we run out of ring entries to store the packets.  With 16
#   ring entries, this corresponds with a maximum of 16 * 1534 bytes,
#   or just 24KiB.  At gigabit speeds, this would take around 200us to
#   fill.  Increasing this to 512 entries gives us more scope when we
#   have busy workloads, as it increases the ring to 767K, and around
#   6.3ms.
# 
#   Signed-off-by: Russell King
# 
#   87589a020fd976e17cf3d03b5c6edff64c0860f9
#    drivers/net/ethernet/freescale/fec.h | 2 +-
#    1 file changed, 1 insertion(+), 1 deletion(-)
# 
# Author:    Russell King (Tue 25 Mar 21:41:35 GMT 2014)
# Committer: Russell King (Fri 17 Oct 14:35:00 BST 2014)
# 
#   net: fec: add byte queue limits support
# 
#   Add support for byte queue limits, which allows the network schedulers
#   to control packet latency and packet queues more accurately.  Further
#   information on this feature can be found at
#   https://lwn.net/Articles/469652/
# 
#   Signed-off-by: Russell King
# 
#   ce257edf6137957234ac28d0c47765bab5fa5bb0
#    drivers/net/ethernet/freescale/fec_main.c | 10 ++++++++++
#    1 file changed, 10 insertions(+)
# 
# Author:    Russell King (Sun 31 Aug 23:49:45 BST 2014)
# Committer: Russell King (Fri 17 Oct 14:34:59 BST 2014)
# 
#   net: fec: improve UDP performance
# 
#   UDP performance is extremely poor.  iperf reports UDP receive speeds in
#   the range of 50Mbps with a high packet loss.  The interface typically
#   reports a few thousand overrun errors per iperf run.  This is far from
#   satisfactory.
# 
#   Adjust the receive FIFO thresholds to reduce the number of errors.
# 
#   Firstly, we decrease RAFL (receive almost full threshold) to the minimum
#   value of 4, which gives us the maximum available space in the FIFO prior
#   to indicating a FIFO overrun condition.
# 
#   Secondly, we adjust the RSEM value to send a XOFF pause frame early
#   enough that an in-progress transmission can complete without overflowing
#   the FIFO.
# 
#   Document these registers and the changes being made in the driver.
# 
#   Signed-off-by: Russell King
# 
#   a9f1d3b0144d7ed328d4bc84b1fbb459ee725ecc
#    drivers/net/ethernet/freescale/fec_main.c | 28 +++++++++++++++++++++++++---
#    1 file changed, 25 insertions(+), 3 deletions(-)
# 
# Author:    Russell King (Thu 27 Mar 00:43:24 GMT 2014)
# Committer: Russell King (Fri 17 Oct 14:34:57 BST 2014)
# 
#   net: fec: improve flow control support
# 
#   The FEC hardware in iMX6 is capable of separate control of each flow
#   control path: the receiver can be programmed via the receive control
#   register to detect flow control frames, and the transmitter can be
#   programmed via the receive FIFO thresholds to enable generation of
#   pause frames.
# 
#   This means we can implement the full range of flow control: both
#   symmetric and asymmetric flow control.  We support ethtool configuring
#   all options: forced manual mode, where each path can be controlled
#   individually, and autonegotiation mode.
# 
#   In autonegotiation mode, the tx/rx enable bits can be used to influence
#   the outcome, though they don't precisely define which paths will be
#   enabled.  One combination we don't support is "symmetric only" since we
#   can always configure each path independently, a case which Linux seems
#   to often get wrong.
# 
#   Signed-off-by: Russell King
# 
#   448ec18793c04686482f8eb9b5d43f0928595952
#    drivers/net/ethernet/freescale/fec.h      |   3 +-
#    drivers/net/ethernet/freescale/fec_main.c | 196 ++++++++++++++++++++++--------
#    2 files changed, 146 insertions(+), 53 deletions(-)
# 
# Author:    Russell King (Wed 18 Jun 18:45:42 BST 2014)
# Committer: Russell King (Fri 17 Oct 14:34:55 BST 2014)
# 
#   net: fec: verify checksum offset
# 
#   Verify that the checksum offset is inside the packet header before
#   we zero the entry.  This ensures that we don't perform an out of
#   bounds write.
# 
#   Signed-off-by: Russell King
# 
#   d8443cd7cb592b302d993cb4c6b55dec6b94d790
#    drivers/net/ethernet/freescale/fec_main.c | 9 +++++++++
#    1 file changed, 9 insertions(+)
# 
# Author:    Russell King (Thu  3 Apr 00:55:57 BST 2014)
# Committer: Russell King (Fri 17 Oct 14:34:54 BST 2014)
# 
#   net: fec: avoid hitting transmitter if it is still running
# 
#   Signed-off-by: Russell King
# 
#   9f2bfe818ec71806d5a0defd2a5c9bacce7998cb
#    drivers/net/ethernet/freescale/fec_main.c | 6 ++++--
#    1 file changed, 4 insertions(+), 2 deletions(-)
# 
# Author:    Russell King (Tue 11 Mar 11:09:13 GMT 2014)
# Committer: Russell King (Fri 17 Oct 14:34:52 BST 2014)
# 
#   net: fec: ensure that we dma unmap the transmit descriptors
# 
#   On transmit timeout or close, dirty transmit descriptors were not being
#   correctly cleaned: the only time that DMA mappings are cleaned is when
#   scanning the TX ring after a transmit interrupt.  Fix this.
# 
#   Signed-off-by: Russell King
# 
#   e3ce425b0ad0e862234cecec2695b8b35d5cc3ae
#    drivers/net/ethernet/freescale/fec_main.c | 19 ++++++++++++++++---
#    1 file changed, 16 insertions(+), 3 deletions(-)
# 
# Author:    Russell King (Tue  1 Apr 23:06:09 BST 2014)
# Committer: Russell King (Fri 17 Oct 14:34:50 BST 2014)
# 
#   net: fec: fix receive error handling
# 
#   The FEC receive error handling suffers from several problems:
#   1. When a FIFO overrun error occurs, the descriptor is closed and
#      reception stops.  The remainder of the packet is discarded by the
#      MAC.
# 
#      The documentation states that other status bits are invalid, and they
#      will be zero.  However, practical experience on iMX6 shows this is
#      not the case - the CR (crc error) bit will also be set.
# 
#      This leads to each FIFO overrun event incrementing both the fifo
#      error count and the crc error count, which makes the error statistics
#      less useful.  Fix this by ignoring all other status bits of the FIFO
#      overrun is set, and add a comment to that effect.
# 
#   2. A late collision invalidates all but the overrun condition; the
#      remaining error conditions must be ignored.
# 
#   3. Despite accounting for errors, it continues to receive the errored
#      packets and pass them into the network stack as if they were
#      correctly received.
# 
#   Signed-off-by: Russell King
# 
#   313c7fd3bb73c5ff942d48020bd6e3cc11a4f935
#    drivers/net/ethernet/freescale/fec.h      |  1 +
#    drivers/net/ethernet/freescale/fec_main.c | 47 ++++++++++++++++++-------------
#    2 files changed, 28 insertions(+), 20 deletions(-)
# 
diff --git a/arch/arm/mm/fault.c b/arch/arm/mm/fault.c
index eb8830a4c5ed..f3961a71d1f4 100644
--- a/arch/arm/mm/fault.c
+++ b/arch/arm/mm/fault.c
@@ -553,6 +553,7 @@ do_DataAbort(unsigned long addr, unsigned int fsr, struct pt_regs *regs)
 
 	printk(KERN_ALERT "Unhandled fault: %s (0x%03x) at 0x%08lx\n",
 		inf->name, fsr, addr);
+	WARN_ON(1);
 
 	info.si_signo = inf->sig;
 	info.si_errno = 0;
